<?php 

class Index extends MY_Controller
{
   
    protected $m;
    public function __construct()
    {
        parent::__construct();

    }

    public function index()
    {
        
            $choose_collection_patient = 'patient_mapping';
            
            if($this->input->post('choose-patient-value')){
                $choose_patient = $this->input->post('choose-patient-value');
               $this->session->set_userdata('choose_patient', $choose_patient);
               $choose_patient = $this->session->userdata("choose_patient");
            }else{
                $choose_patient = $this->session->userdata("choose_patient");
            }
            
           	if($choose_patient){
           	    $choose_collection_patient = $choose_patient;
           	}else{
               $choose_collection_patient = 'patient_mapping';
            }
                
                $date = $this->input->post('date');
                $today = date("Y/m/d");
                $dates = new DateTime($today);
                
                $recent = $today;
                $config = array();
                
                if($date){
                    $config['base_url'] = base_url() . 'index?date='.$date;
                }else{
                    $date = $this->input->get('date');
                    if($date != ''){
                        $config['base_url'] = base_url() . 'index?date='.$date;
                    }else{
                        $config['base_url'] = base_url() . 'index';
                    }
                }
                
                $recent = modify_date($date, $dates);
                
                $patient_id = '';
                if(!$date){
                    if($this->input->post('search-id')){
                        $patient_id = $this->input->post('search-id');
                       $config['base_url'] = base_url() . 'index?search='.$patient_id;
                    }else{
                        $patient_id = $this->input->get('search');
                        if($patient_id != ''){
                            $config['base_url'] = base_url() . 'index?search='.$patient_id;
                        }else{
                            $config['base_url'] = base_url() . 'index';
                        }
                    }
                }
                
                if($patient_id != ''){
                   
                    $data_real_id = $this->events_model->search_patient($choose_collection_patient, $patient_id);
                    
                    $a_r = array();
                    foreach($data_real_id as $v){
                        $a_r[] = $v['patient_random'];
                    }
                }
                
                
                $template['patient_id_search'] = $patient_id;
                $nums_total = $this->events_model->count_all_events($recent);
                $config['total_rows'] = $patient_id != '' ? count($a_r) : $nums_total['result'][0]['count'] ;
                $config['per_page'] = 20;
                $config['page_query_string'] = true;
                $config['query_string_segment'] = 'offset';
                $this->load->library('pagination', $config);
                $this->pagination->initialize($config);
                $start = 0;
                if($this->input->get('offset')){
                    $start = $this->input->get('offset');
                }
                $sort = -1;
                if($this->input->post('up') == 'up'){
                    $sort = 1;
                }
                //get all events and get all events by date
                $data = $this->events_model->find_all_events($recent, $patient_id, $a_r, $choose_collection_patient, $start, $config['per_page']);
                //get all events by typ1 1 and by date
               
            $data_1 = $this->events_model->find_all_events_by_type1($recent, $patient_id,  $a_r, $sort);
    
            //$count_documents = iterator_to_array($collection->find());
            //$template['count_documents'] = $count_documents;
            $template['sort'] = $sort;
            $template['data_1'] = $data_1;
            $template['val'] = $date;
            $template['data'] = $data;
            $template['subview'] = 'index';
            $this->load->view('layouts/main', $template);
    }
    public function providers(){
        $this->my_providers(); 
    }
    public function medications(){
        $this->my_medications();
    }
    public function encounters(){
        $this->my_encounters();
    }
    public function listEvents(){
        $this->my_listEvents();  
    }
    public function type2(){
        $this->my_type2();
    }
    public function eventDetail(){
        $this->my_eventDetail();
    }
     public function medrec(){
        $this->my_medrec();
    }
    public function confirm(){
        $this->my_confirm();
    }
  }

?>