<?php 

class MY_Controller extends CI_Controller
{
   
    protected $m;
    public function __construct()
    {
        parent::__construct();
        $this->m = new MongoClient('mongodb://quang:quang@cluster0-shard-00-00-lra5a.mongodb.net:27017,cluster0-shard-00-01-lra5a.mongodb.net:27017,cluster0-shard-00-02-lra5a.mongodb.net:27017/admin?ssl=true&replicaSet=Cluster0-shard-0');
        $this->load->model('events_model');
        $this->load->helper('date_helper');
        
        $user_login = $this->session->userdata("user_id");
        if($user_login == '') {
            redirect(base_url().'user/login');
        }
        $controller = $this->uri->segment('1');
        
        switch ($controller){
            case '':{
                $this->check_admin();
                break;
            }
            case 'index':{
            
                $this->check_admin();
                break;
            }
            case 'doctor':{
                $this->check_doctor();
                break;
            }
            case 'patient':{
                $this->check_patient();
                break;
            }
            
        }
    }
    public function check_admin(){
        $controller = $this->uri->rsegment('1');
        $controller = strtolower($controller);
        $type = $this->session->userdata('type');
        if($type == 'admin'){
            if($controller == 'user/login'){
                redirect(base_url());
            }
        }else{
            redirect(base_url().'error');
        }
        
    }
    public function check_doctor(){
        $controller = $this->uri->rsegment('1');
        $controller = strtolower($controller);
        $type = $this->session->userdata('type');
        if($type == 'doctor' or $type == 'admin'){
            if($controller == 'user/login'){
                redirect(base_url().'doctor');
            }
        }else{
            redirect(base_url().'error');
        }
        
    }
    public function check_patient(){
        $controller = $this->uri->rsegment('1');
        $controller = strtolower($controller);
        $type = $this->session->userdata('type');
        if($type  == 'patient' or $type == 'doctor' or $type == 'admin'){
            if($controller == 'user/login'){
                redirect(base_url().'patient');
            }
        }else{
            redirect(base_url().'error');
        }
        
    }
   
    public function my_providers()
     
    {
        
        $choose_collection_patient = 'patient_mapping';
        
        $choose_patient = $this->session->userdata("choose_patient");
       	if($choose_patient){
       	    $choose_collection_patient = $choose_patient;
       	}
        $patient_id = $this->input->get('id');

        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("events");
        
        $date = $this->input->post('date');
        if ($this->input->get('date'))
        {
            $date = $this->input->get('date');
        }

        $today = date("Y/m/d");
        $date_time = new DateTime($today);

        $recent = $today;
        $recent = modify_date($date, $dates);
        
        $sort = -1;
        if ($this->input->post('up') == 'up')
        {
            $sort = 1;
        }
        
        $last_encountered = $collection->aggregate(array(

            array('$match' => array('$or' => array(
                        array(
                            "patient" => $patient_id,
                            "type1" => "Hospital Dr Encounter",
                            "date" => array('$gte' => new MongoDate(strtotime($recent))),
                            ),
                        array(
                            "patient" => $patient_id,
                            "type1" => "Visit",
                            "date" => array('$gte' => new MongoDate(strtotime($recent))),
                            ),
                        array(
                            "patient" => $patient_id,
                            "type1" => "ER Dr. encounter",
                            "date" => array('$gte' => new MongoDate(strtotime($recent))),
                            ),
                        )), ),

            array('$group' => array(
                    '_id' => array('who' => '$who'),
                    'date' => array('$max' => '$date'),
                    'books' => array('$push' => '$Who'),

                    )),

            array('$sort' => array('date' => $sort)),


            ));

        $data = $last_encountered['result'];


        $last_encountered_1 = $collection->aggregate(array(

            array('$match' => array(
                    "patient" => $patient_id,
                    "date" => array('$gte' => new MongoDate(strtotime($recent))),

                    ), ),

            array('$group' => array(
                    '_id' => array('who' => '$who'),
                    'date' => array('$max' => '$date'),
                    'books' => array('$push' => '$Who'),

                    )),

            array('$sort' => array('date' => $sort)),

            ));

        $data_1 = $last_encountered_1['result'];

        $a1 = array();

        foreach ($data as $key => $value)
        {
            $b = $data[$key];
            $b1 = $b['_id'];
            $b2 = $b['date'];
            $b4 = $b['books'];

            $b5_next_scheduled = "";
            $b5_name_of_practice = "";
            $b5_doctor_specialty = "";
            $b5_phone_number = "";
            $b5_purpose_of_last_visit = "";
            if (count($b4) > 0)
            {
                $b5 = $b4[0];


                if (isset($b5['next_scheduled']->sec))
                {
                    $b5_next_scheduled = date('Y-M-d', $b5['next_scheduled']->sec);
                }

                if (isset($b5['name_of_practice']))
                {
                    $b5_name_of_practice = $b5['name_of_practice'];
                }

                if (isset($b5['Doctor_Speciality']))
                {
                    $b5_doctor_specialty = $b5['Doctor_Speciality'];
                }

                if (isset($b5['phone_number']))
                {
                    $b5_phone_number = $b5['phone_number'];
                }

                if (isset($b5['purpose_of_last_visit']))
                {
                    $b5_purpose_of_last_visit = $b5['purpose_of_last_visit'];
                }


            }
            $a1[] = array(
                'name_of_practice' => $b5_name_of_practice,
                'doctor_specialty' => $b5_doctor_specialty,
                'phone_number' => $b5_phone_number,
                'last_encountered' => date('Y-M-d', $b2->sec),
                'next_scheduled' => $b5_next_scheduled,
                'purpose_of_last_visit' => $b5_purpose_of_last_visit,
                'who' => $b1['who'],

                );


        }

        $a11 = array();
        foreach ($data_1 as $key => $value)
        {
            $b = $data_1[$key];
            $b1 = $b['_id'];
            $b2 = $b['date'];

            $b4 = $b['books'];

            $b5_next_scheduled = "";
            $b5_name_of_practice = "";
            $b5_doctor_specialty = "";
            $b5_phone_number = "";
            $b5_purpose_of_last_visit = "";
            if (count($b4) > 0)
            {
                $b5 = $b4[0];

                if (isset($b5['next_scheduled']->sec))
                {
                    $b5_next_scheduled = date('Y-M-d', $b5['next_scheduled']->sec);
                }

                if (isset($b5['name_of_practice']))
                {
                    $b5_name_of_practice = $b5['name_of_practice'];
                }

                if (isset($b5['Doctor_Speciality']))
                {
                    $b5_doctor_specialty = $b5['Doctor_Speciality'];
                }

                if (isset($b5['phone_number']))
                {
                    $b5_phone_number = $b5['phone_number'];
                }

                if (isset($b5['purpose_of_last_visit']))
                {
                    $b5_purpose_of_last_visit = $b5['purpose_of_last_visit'];
                }

            }

            $a11[] = array(
                'name_of_practice' => $b5_name_of_practice,
                'doctor_specialty' => $b5_doctor_specialty,
                'phone_number' => $b5_phone_number,
                'last_encountered' => date('Y-M-d', $b2->sec),
                'next_scheduled' => $b5_next_scheduled,
                'purpose_of_last_visit' => $b5_purpose_of_last_visit,
                'who' => $b1['who'],

                );


        }
        
        $sort = -1;
        if ($this->input->post('up') == 'up')
        {
            $sort = 1;
        }
        
        $collection_patient = $db->selectCollection($choose_collection_patient);
        $condition_patient = array("patient_random" => $patient_id,);
        $patient_name = $collection_patient->find($condition_patient);
        $patient_info = iterator_to_array($patient_name);
    
        
        $template['patient_info'] = $patient_info;
        $template['sort'] = $sort;
        $template['data'] = $a1;
        $template['data_1'] = $a11;
        $template['val'] = $date;
        $template['patient_id'] = $patient_id;
        $template['subview'] = 'patient/providers';
        
        $this->load->view('layouts/main', $template);
        
    }
    public function my_medications()
    {
        
        $choose_collection_patient = 'patient_mapping';
        
        $choose_patient = $this->session->userdata("choose_patient");
       	if($choose_patient){
       	    $choose_collection_patient = $choose_patient;
       	}
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("events");
        
        $patient_id = $this->input->get('id');

        $date = $this->input->post('date');
        if ($this->input->get('date'))
        {
            $date = $this->input->get('date');
        }
        $today = date("Y/m/d");
        $date_time = new DateTime($today);

        $recent = $today;
        if ($date == 1)
        {
            $recent = $date_time->modify('-1 month')->format('Y-m-d');
        }
        if ($date == 2)
        {
            $recent = $date_time->modify('-2 month')->format('Y-m-d');
        }

        if ($date == '' or $date == 'active')
        {
            $recent = date('1970-01-01');
        }
        $datas = $collection->aggregate(array(array('$match' => array(
                    "patient" => $patient_id,
                    "date" => array('$gte' => new MongoDate(strtotime($recent))),
                    ), ), ));

        $data = $datas['result'];

        $record = array();
        $b8 = array();
        $b81 = array();
        $b82 = array();
        $b83 = array();
        $b8_medactive = array();
        $b8_medactive_type2 = array();
        foreach ($data as $key => $val)
        {

            $b6 = $data[$key];
            if (isset($b6['medication_name']))
            {
                if ($b6['medication_name'] != '')
                {
                    $b8[] = $b6['medication_name'];
                    $b81[] = date('Y-m-d H:i:s', $b6['date']->sec);
                    $b8_medactive[] = $b6['type1'];
                    if (isset($b6['type2']))
                    {
                        $b8_medactive_type2[] = $b6['type2'];
                    }
                    if (isset($b6['who']))
                    {
                        $b8_who[] = $b6['who'];
                    } else
                    {
                        $b8_who[] = '';
                    }
                    if (isset($b6['providerId']))
                    {
                        $b8_providerId[] = $b6['providerId'];
                    } else
                    {
                        $b8_providerId[] = '';
                    }
                    if (isset($b6['event_type']))
                    {
                        $b83[] = $b6['event_type'];
                    } else
                    {
                        $b83[] = "";
                    }
                    if (isset($b6['dosage']))
                    {
                        $b84[] = $b6['dosage'];
                    } else
                    {
                        $b84[] = "";
                    }
                    if (isset($b6['dosage_unit']))
                    {
                        $b85[] = $b6['dosage_unit'];
                    } else
                    {
                        $b85[] = "";
                    }
                }
            }


        }
        asort($b81);

        $b10 = array(); //array sort
        foreach ($b81 as $key => $val)
        {
            $b10[] = array(
                'date' => $b81[$key],
                'medication_name' => $b8[$key],
                'event_type' => $b83[$key],
                'dosage' => $b84[$key],
                'type1' => $b8_medactive[$key],
                'type2' => $b8_medactive_type2[$key],
                'who' => $b8_who[$key],
                'dosage_unit' => $b85[$key],
                'providerId' => $b8_providerId[$key],

                );
        }

        $b10_1 = array(); //array medication
        foreach ($b10 as $key => $val)
        {
            $_a = $b10[$key];
            if ($_a['medication_name'] == 'No Medication')
            {
                $b10_1[$key] = $_a;
                break;
            }
        }
        $medication_recent = count($b10);

        foreach ($b10_1 as $key => $value)
        {
            $medication_recent = $key;
            break; //key medication recent

        }

        $medication_active = array();
       
        if ($this->input->get('medication'))
        {
            $date = $this->input->get('medication');
        }

        for ($i = 0; $i < $medication_recent; $i++)
        {
            
            $_b = $b10[$i];
            
            if ($_b['medication_name'] != 'No Medication' && ($_b['type1'] == 'Medication' && $_b['type2'] ==
                'Prescription'))
            {
                if (count($medication_active) > 0)
                {
                    $k = 0;
                    foreach ($medication_active as $key => $val)
                    {
                        if ($val['medication'] == $_b['medication_name'])
                        {
                            $k++;
                            if ($val['status'] == 'inactive')
                            {
                                $medication_active[$key] = array(
                                    "medication" => $_b['medication_name'],
                                    "startdate" => $_b['date'],
                                    "status" => 'active',
                                    "dosage" => $_b['dosage'],
                                    "providerId" => $_b['providerId'],
                                    );

                            }
                        } 
                    }
                    if($k == 0){
                        $medication_active[$i] = array(
                                "medication" => $_b['medication_name'],
                                "startdate" => $_b['date'],
                                "status" => 'active',
                                "dosage" => $_b['dosage'],
                                "providerId" => $_b['providerId'],
                                );
                    }
                    
                } else
                {
                    $medication_active[$i] = array(
                        "medication" => $_b['medication_name'],
                        "startdate" => $_b['date'],
                        "status" => 'active',
                        "dosage" => $_b['dosage'],
                        "providerId" => $_b['providerId'],
                        );

                }


            }
            if ($_b['medication_name'] != 'No Medication' && (($_b['type1'] == 'Medication' && ($_b['type2'] ==
                'Prescription-Stop' || $_b['type2'] == 'Prescription-End')) or ($_b['type1'] == 'MedRec'  && $_b['type2'] == 'Stop')))
            {
                if (count($medication_active) > 0)
                {
                    foreach ($medication_active as $key => $val)
                    {
                        if ($val['medication'] == $_b['medication_name'])
                        {
                            $medication_active[$key] = array(
                                "medication" => $_b['medication_name'],
                                "startdate" => $val['startdate'],
                                "stopdate" => $_b['date'],
                                "status" => 'inactive',
                                "dosage" => $_b['dosage'],
                                "providerId" => $_b['providerId'],
                                );

                        }
                    }
                }
            }


        }


        $collection_patient = $db->selectCollection($choose_collection_patient);
        $condition_patient = array("patient_random" => $patient_id, );
        $patient_name = $collection_patient->find($condition_patient);
        $patient_info = iterator_to_array($patient_name);
       
        $template['patient_info'] = $patient_info;
        $template['data'] = $medication_active;
        $template['val'] = $date;
        $template['patient_id'] = $patient_id;
        
        $template['subview'] = 'patient/medications';
        $this->load->view('layouts/main', $template);
        
    }
    public function my_encounters()
    {
        
        $choose_collection_patient = 'patient_mapping';
        
        $choose_patient = $this->session->userdata("choose_patient");
       	if($choose_patient){
       	    $choose_collection_patient = $choose_patient;
       	}
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("events");
        $collection_doctor = $db->selectCollection("doctor");
        

        $patient_id = $this->input->get('id');


        $datas = $collection->aggregate(array(
            array('$match' => array('$or' => array(
                        array(
                            "patient" => $patient_id,
                            "type1" => "Hospital Dr Encounter",
                            ),
                        array(
                            "patient" => $patient_id,
                            "type1" => "Visit",
                            ),
                        array(
                            "patient" => $patient_id,
                            "type1" => "ER Dr. encounter",
                            ),
                        ), ), ),

            array('$lookup' => array(
                    'from' => 'doctor',
                    'localField' => 'who',
                    'foreignField' => 'who',
                    'as' => 'doctor')),
            ));

        $data = $datas['result'];

        $record = array();
        foreach ($data as $key => $val)
        {

            $a = $data[$key];
            $a1 = date('Y-m-d H:i:s', $a['date']->sec);
            //$a1_time = date('H:i:s',$a['date']->usec);
            $a2 = $a['type1'];
            $a3 = $a['doctor'];
            if (count($a3) > 0)
            {
                $a4 = $a3[0];
            }
            $a5 = '';
            if (isset($a['type2']))
            {
                $a5 = $a['type2'];
            }

            //print_r($a1->format('Y-m-d H:i:s'));die();
            foreach ($re as $name)
            {
                $record[] = array(
                    'date_time' => $a1,
                    //'time' =>$a1_time,
                    'type1' => $a2,
                    'name_of_practice' => $a4['name_of_practice'],
                    'phone_number' => $a4['phone_number'],
                    'purpose_of_encounter' => $a5,
                    'patient_name' => $name['name'],
                    'who' => $a4['who'],

                    );
            }
        }
        $collection_patient = $db->selectCollection($choose_collection_patient);
        $condition_patient = array("patient_random" => $patient_id, );
        $patient_name = $collection_patient->find($condition_patient);
        $patient_info = iterator_to_array($patient_name);
     
        $template['patient_info'] = $patient_info;
        $template['data'] = $record;
        
        $template['subview'] = 'patient/encounters';
        $this->load->view('layouts/main', $template);
       
    }
     public function my_listEvents()
    {
        
        $choose_collection_patient = 'patient_mapping';
        
        $choose_patient = $this->session->userdata("choose_patient");
       	if($choose_patient){
       	    $choose_collection_patient = $choose_patient;
       	}
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("events");

        $id = $this->input->get('id');
        $medication = $this->input->get('medication');
        $yes = 0;
        $type1_condition = array(
            "patient" => $id,
            'medication_name' =>  $medication != '' ? $medication : array('$exists' => true),
        );
        
        
        $document_type1 = $collection->find($type1_condition);
        $data_type1 = iterator_to_array($document_type1);
        
        $data_list_type1 = array();
        foreach ($data_type1 as $value)
        {
            if ($value['type1'] != '')
            {
                $data_list_type1[] = $value['type1'];
            }
        }

        $val_type1 = $this->input->post('type1');
        $data_list_type1 = array_unique($data_list_type1);
        
        
        $template['data_list_type1'] = $data_list_type1;
        $template['val_type1'] = $val_type1;
        
        $con = array(
            "type1" => $val_type1,
            "patient" => $id,
            'medication_name' =>  $medication != '' ? $medication : array('$exists' => true),
            );
        
        $record = $collection->find($con);
        $data_ecord = iterator_to_array($record);
        $data_ecord_type2 = array();
        foreach ($data_ecord as $val)
        {
            if (isset($val['type2']))
            {
                $data_ecord_type2[] = trim($val['type2']);
            }

        }

        $data_record = array_unique($data_ecord_type2);


        $type2 = '';
        if ($this->input->post('type2') != '')
        {
            $type2 = $this->input->post('type2');
        }

        $encouter = '';
        if ($this->input->post('type1') != '')
        {
            $encouter = $this->input->post('type1');
        }

        $sort = -1;
        if ($this->input->post('up') == 'up')
        {
            $sort = 1;
        }

        if ($type2 == '' && $encouter == '')
        {
            $yes = 1;
           
            $listDocument_total = $collection->aggregate(array(array('$match' => array(
                "patient" => $id,
                'medication_name' =>  $medication != '' ? $medication : array('$exists' => true),
                ), ), ));

            $data_total = $listDocument_total['result'];
            $config = array();
            $config['base_url'] = base_url() .'index/listEvents?id=' . $id;
            if($medication != ''){
                $config['base_url'] = base_url() .'index/listEvents?id=' . $id.'&medication='.$medication;
            }
            
            $config['total_rows'] = count($data_total);
            $config['per_page'] = 20;
            $config['page_query_string'] = true;
            $config['query_string_segment'] = 'offset';
            $this->load->library('pagination', $config);
            $this->pagination->initialize($config);
            $start = 0;
            if ($this->input->get('offset') > 0)
            {
                $start = $this->input->get('offset');
            }
            $listDocument = $collection->aggregate(array(
                array('$match' => array(
                    "patient" => $id,
                    'medication_name' =>  $medication != '' ? $medication : array('$exists' => true),
                 ), ),
                array('$sort' => array('date' => $sort)),
                array('$skip' => (int)$start),
                array('$limit' => $config['per_page']),

                ));
            $data = $listDocument['result'];
        }

        if ($type2 != '' && $encouter == '')
        {

            $listDocument = $collection->aggregate(array(
                array('$match' => array(
                        "patient" => $id,
                        "type2" => $type2,
                        "type1" => 'Medication',
                        
                        ), ),
                array('$sort' => array('date' => $sort)),

                ));
            $data = $listDocument['result'];
        }
        if ($type2 == '' && $encouter != '')
        {
            $listDocument = $collection->aggregate(array(
                array('$match' => array(
                        "patient" => $id,
                        "type1" => $encouter,
                        
                        ), ),
                array('$sort' => array('date' => $sort)),

                ));
            $data = $listDocument['result'];
        }
        if ($type2 != '' && $encouter != '')
        {
            $listDocument = $collection->aggregate(array(
                array('$match' => array(
                        "patient" => $id,
                        "type2" => $type2,
                        "type1" => $encouter,
                        
                        ), ),
                array('$sort' => array('date' => $sort)),

                ));
            $data = $listDocument['result'];
        }
        $collection_patient = $db->selectCollection($choose_collection_patient);
        $condition_patient = array("patient_random" => $id, );
        $patient_name = $collection_patient->find($condition_patient);
        $patient_info = iterator_to_array($patient_name);

        $val = $this->input->post('type2');
        $val_encouter = $this->input->post('encouter');
        
        
        $template['id'] = $id;
        
        $template['patient_info'] = $patient_info;
        $template['yes'] = $yes;
        $template['sort'] = $sort;
        $template['data_ecord'] = $data_record;
        $template['val'] = $val;
        $template['val_encouter'] = $val_encouter;
        $template['data'] = $data;
        
        $template['subview'] = 'patient/listEvents';
        $this->load->view('layouts/main', $template);
        
    }
    public function my_type2(){
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("events");
        
        $type1 = $this->input->post('type1_select');
        $id = $this->input->post('id');
         $type1_condition = array(
            "patient" => $id, 
            "type1" => $type1, 
        );
        $document = $collection->find($type1_condition);
        $data = iterator_to_array($document);
       
        
        $re = array();
        foreach($data as $value){
            if(isset($value['type2']) && $value['type2'] != ''){
                $re[] = $value['type2'];
                
            }
        }
        $re = array_unique($re);
        $record = array();
        foreach($re as $val){
            $record[] = array(
                    'type2' => $val,
                );
        }
        
        echo json_encode($record);
    }
    public function my_eventDetail(){
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("events");
        $id = $this->input->post('id');
        //$id = '57c67849a8b9dcd80b00002d';
        $condition = array(
                "_id" => new MongoId($id),
            );
        
         $record = $collection->find($condition);
         $data_ecord = iterator_to_array($record);
         
         $data = array();
         foreach($data_ecord as $value){
            $patient = '';
            if(isset($value['patient'])){
                $patient = $value['patient'];
            }
             $category = '';
            if(isset($value['category'])){
                $category = $value['category'];
            }
             $eventid = '';
            if(isset($value['eventid'])){
                $eventid = $value['eventid'];
            }
             $date = '';
            if(isset($value['date'])){
                $date = $value['date'];
            }
             $type1 = '';
            if(isset($value['type1'])){
                $type1 = $value['type1'];
            }
             $type2 = '';
            if(isset($value['type2'])){
                $type2 = $value['type2'];
            }
             $location = '';
            if(isset($value['location'])){
                $location = $value['location'];
            }
             $who = '';
            if(isset($value['who'])){
                $who = $value['who'];
            }
            $whotype = '';
            if(isset($value['whotype'])){
                $whotype = $value['whotype'];
            }
            $pdflink = '';
            if(isset($value['pdflink'])){
                $pdflink = $value['pdflink'];
            }
             $medication_form = '';
            if(isset($value['medication_form'])){
                $medication_form = $value['medication_form'];
            }
             $med_desc = '';
            if(isset($value['med_desc'])){
                $med_desc = $value['med_desc'];
            }
             $iv_end = '';
            if(isset($value['iv_end'])){
                $iv_end = $value['iv_end'];
            }
             $iv_start = '';
            if(isset($value['iv_start'])){
                $iv_start = $value['iv_start'];
            }
             $medication_name = '';
            if(isset($value['medication_name'])){
                $medication_name = $value['medication_name'];
            }
             $linkevent = '';
            if(isset($value['linkevent'])){
                $linkevent = $value['linkevent'];
            }
            $pers_dose_day = '';
            if(isset($value['pers_dose_day'])){
                $pers_dose_day = $value['pers_dose_day'];
            }
            $med_sol_unit = '';
            if(isset($value['med_sol_unit'])){
                $med_sol_unit = $value['med_sol_unit'];
            }
            $med_solution = '';
            if(isset($value['med_solution'])){
                $med_solution = $value['med_solution'];
            }
            $dosage_unit = '';
            if(isset($value['dosage_unit'])){
                $dosage_unit = $value['dosage_unit'];
            }
            $dosage = '';
            if(isset($value['dosage'])){
                $dosage = $value['dosage'];
            }
            
             $measurement = '';
            if(isset($value['measurement'])){
                $measurement = $value['measurement'];
            }
            $data[] = array(
                'patient' => $patient,
                'category' => $category,
                'eventid' => $eventid,
                'date' => date('Y-m-d',$date->sec),
                'linkevent' => $linkevent,
                'type1' => $type1,
                'type2' => $type2,
                'who' => $who,
                'location' => $location,
                'whotype' => $whotype,
                'pdflink' => $pdflink,
                'iv_end' => $iv_end,
                'iv_start' => $iv_start,
                'medication_name' => $medication_name,
                'pers_dose_day' => $pers_dose_day,
                'med_sol_unit' => $med_sol_unit,
                'med_solution' => $med_solution,
                'dosage_unit' => $dosage_unit,
                'dosage' => $dosage,
                'med_desc' => $med_desc,
                'medication_form' => $medication_form,
                'measurement' => $measurement,
                
                
            );
         }
         
         echo json_encode($data);
     }
     public function my_medrec(){
        $user_login = $this->session->userdata("user_id");
        
        $choose_collection_patient = 'patient_mapping';
        $choose_patient = $this->session->userdata("choose_patient");
       	if($choose_patient){
       	    $choose_collection_patient = $choose_patient;
       	}
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("events");
        $patient_id = $this->input->get('id');
     
      
        $datas = $collection->aggregate(array(array('$match' => array(
                    "patient" => $patient_id,
                    //"who" => $user_login,
                    ),),));
        
        $data = $datas['result'];

        $record = array();
        $b8 = array();
        $b81 = array();
        $b82 = array();
        $b83 = array();
        $b8_medactive = array();
        $b8_medactive_type2 = array();
        foreach ($data as $key => $val)
        {

            $b6 = $data[$key];
            if (isset($b6['medication_name']))
            {
                if ($b6['medication_name'] != '')
                {
                    $b8[] = $b6['medication_name'];
                    $b81[] = date('Y-m-d H:i:s', $b6['date']->sec);
                    $b8_medactive[] = $b6['type1'];
                    if (isset($b6['type2']))
                    {
                        $b8_medactive_type2[] = $b6['type2'];
                    }
                    if (isset($b6['who']))
                    {
                        $b8_who[] = $b6['who'];
                    } else
                    {
                        $b8_who[] = '';
                    }
                    if (isset($b6['providerId']))
                    {
                        $b8_providerId[] = $b6['providerId'];
                    } else
                    {
                        $b8_providerId[] = '';
                    }
                    if (isset($b6['event_type']))
                    {
                        $b83[] = $b6['event_type'];
                    } else
                    {
                        $b83[] = "";
                    }
                    if (isset($b6['dosage']))
                    {
                        $b84[] = $b6['dosage'];
                    } else
                    {
                        $b84[] = "";
                    }
                    if (isset($b6['dosage_unit']))
                    {
                        $b85[] = $b6['dosage_unit'];
                    } else
                    {
                        $b85[] = "";
                    }
                }
            }


        }
        asort($b81);

        $b10 = array(); //array sort
        foreach ($b81 as $key => $val)
        {
            $b10[] = array(
                'date' => $b81[$key],
                'medication_name' => $b8[$key],
                'event_type' => $b83[$key],
                'dosage' => $b84[$key],
                'type1' => $b8_medactive[$key],
                'type2' => $b8_medactive_type2[$key],
                'who' => $b8_who[$key],
                'dosage_unit' => $b85[$key],
                'providerId' => $b8_providerId[$key],

                );
        }

        $b10_1 = array(); //array medication
        foreach ($b10 as $key => $val)
        {
            $_a = $b10[$key];
            if ($_a['medication_name'] == 'No Medication')
            {
                $b10_1[$key] = $_a;
                break;
            }
        }
        $medication_recent = count($b10);

        foreach ($b10_1 as $key => $value)
        {
            $medication_recent = $key;
            break; //key medication recent

        }

        $medication_active = array();
        for ($i = 0; $i < $medication_recent; $i++)
        {
            
            $_b = $b10[$i];
            
            if ($_b['medication_name'] != 'No Medication' && ($_b['type1'] == 'Medication' && $_b['type2'] ==
                'Prescription'))
            {
                if (count($medication_active) > 0)
                {
                    $k = 0;
                    foreach ($medication_active as $key => $val)
                    {
                        if ($val['medication'] == $_b['medication_name'])
                        {
                            $k++;
                            if ($val['status'] == 'inactive')
                            {
                                $medication_active[$key] = array(
                                    "medication" => $_b['medication_name'],
                                    "startdate" => $_b['date'],
                                    "status" => 'active',
                                    "dosage" => $_b['dosage'],
                                    "providerId" => $_b['providerId'],
                                    );

                            }
                        } 
                    }
                    if($k == 0){
                        $medication_active[$i] = array(
                                "medication" => $_b['medication_name'],
                                "startdate" => $_b['date'],
                                "status" => 'active',
                                "dosage" => $_b['dosage'],
                                "providerId" => $_b['providerId'],
                                );
                    }
                    
                } else
                {
                    $medication_active[$i] = array(
                        "medication" => $_b['medication_name'],
                        "startdate" => $_b['date'],
                        "status" => 'active',
                        "dosage" => $_b['dosage'],
                        "providerId" => $_b['providerId'],
                        );

                }


            }
            if ($_b['medication_name'] != 'No Medication' && (($_b['type1'] == 'Medication' && ($_b['type2'] ==
                'Prescription-Stop' || $_b['type2'] == 'Prescription-End')) or ($_b['type1'] == 'MedRec'  && $_b['type2'] == 'Stop')))
            {
                if (count($medication_active) > 0)
                {
                    foreach ($medication_active as $key => $val)
                    {
                        if ($val['medication'] == $_b['medication_name'])
                        {
                            $medication_active[$key] = array(
                                "medication" => $_b['medication_name'],
                                "startdate" => $val['startdate'],
                                "stopdate" => $_b['date'],
                                "status" => 'inactive',
                                "dosage" => $_b['dosage'],
                                "providerId" => $_b['providerId'],
                                );

                        }
                    }
                }
            }


        }


        $collection_patient = $db->selectCollection($choose_collection_patient);
        $condition_patient = array("patient_random" => $patient_id, );
        $patient_name = $collection_patient->find($condition_patient);
        $patient_info = iterator_to_array($patient_name);
        
        
        $template['patient_info'] = $patient_info;
        $template['data'] = $medication_active;
        $template['patient_id'] = $patient_id;
        
        $template['subview'] = 'doctor/medrec';
        $this->load->view('layouts/main', $template);
        

    }
    public function my_confirm(){
        
        $choose_collection_patient = 'patient_mapping';
        $choose_patient = $this->session->userdata("choose_patient");
       	if($choose_patient){
       	    $choose_collection_patient = $choose_patient;
       	}
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("events");
        $patient_id = $this->input->get('id');
        
        $datas = $collection->aggregate(array(array('$match' => array(
                    "patient" => $patient_id,
                    ),),));
        
        $data = $datas['result'];

        $record = array();
        $b8 = array();
        $b81 = array();
        $b82 = array();
        $b83 = array();
        $b8_medactive = array();
        $b8_medactive_type2 = array();
        foreach ($data as $key => $val)
        {

            $b6 = $data[$key];
            if (isset($b6['medication_name']))
            {
                if ($b6['medication_name'] != '')
                {
                    $b8[] = $b6['medication_name'];
                    $b81[] = date('Y-m-d H:i:s', $b6['date']->sec);
                    $b8_medactive[] = $b6['type1'];
                    if (isset($b6['type2']))
                    {
                        $b8_medactive_type2[] = $b6['type2'];
                    }
                    if (isset($b6['who']))
                    {
                        $b8_who[] = $b6['who'];
                    } else
                    {
                        $b8_who[] = '';
                    }
                    if (isset($b6['providerId']))
                    {
                        $b8_providerId[] = $b6['providerId'];
                    } else
                    {
                        $b8_providerId[] = '';
                    }
                    if (isset($b6['event_type']))
                    {
                        $b83[] = $b6['event_type'];
                    } else
                    {
                        $b83[] = "";
                    }
                    if (isset($b6['dosage']))
                    {
                        $b84[] = $b6['dosage'];
                    } else
                    {
                        $b84[] = "";
                    }
                    if (isset($b6['dosage_unit']))
                    {
                        $b85[] = $b6['dosage_unit'];
                    } else
                    {
                        $b85[] = "";
                    }
                }
            }


        }
        asort($b81);

        $b10 = array(); //array sort
        foreach ($b81 as $key => $val)
        {
            $b10[] = array(
                'date' => $b81[$key],
                'medication_name' => $b8[$key],
                'event_type' => $b83[$key],
                'dosage' => $b84[$key],
                'type1' => $b8_medactive[$key],
                'type2' => $b8_medactive_type2[$key],
                'who' => $b8_who[$key],
                'dosage_unit' => $b85[$key],
                'providerId' => $b8_providerId[$key],

                );
        }

        $b10_1 = array(); //array medication
        foreach ($b10 as $key => $val)
        {
            $_a = $b10[$key];
            if ($_a['medication_name'] == 'No Medication')
            {
                $b10_1[$key] = $_a;
                break;
            }
        }
        $medication_recent = count($b10);

        foreach ($b10_1 as $key => $value)
        {
            $medication_recent = $key;
            break; //key medication recent

        }

        $medication_active = array();
        for ($i = 0; $i < $medication_recent; $i++)
        {
            
            $_b = $b10[$i];
            
            if ($_b['medication_name'] != 'No Medication' && ($_b['type1'] == 'Medication' && $_b['type2'] ==
                'Prescription'))
            {
                if (count($medication_active) > 0)
                {
                    $k = 0;
                    foreach ($medication_active as $key => $val)
                    {
                        if ($val['medication'] == $_b['medication_name'])
                        {
                            $k++;
                            if ($val['status'] == 'inactive')
                            {
                                $medication_active[$key] = array(
                                    "medication" => $_b['medication_name'],
                                    "startdate" => $_b['date'],
                                    "status" => 'active',
                                    "dosage" => $_b['dosage'],
                                    "providerId" => $_b['providerId'],
                                    );

                            }
                        } 
                    }
                    if($k == 0){
                        $medication_active[$i] = array(
                                "medication" => $_b['medication_name'],
                                "startdate" => $_b['date'],
                                "status" => 'active',
                                "dosage" => $_b['dosage'],
                                "providerId" => $_b['providerId'],
                                );
                    }
                    
                } else
                {
                    $medication_active[$i] = array(
                        "medication" => $_b['medication_name'],
                        "startdate" => $_b['date'],
                        "status" => 'active',
                        "dosage" => $_b['dosage'],
                        "providerId" => $_b['providerId'],
                        );

                }


            }
            if ($_b['medication_name'] != 'No Medication' && (($_b['type1'] == 'Medication' && ($_b['type2'] ==
                'Prescription-Stop' || $_b['type2'] == 'Prescription-End')) or ($_b['type1'] == 'MedRec'  && $_b['type2'] == 'Stop')))
            {
                if (count($medication_active) > 0)
                {
                    foreach ($medication_active as $key => $val)
                    {
                        if ($val['medication'] == $_b['medication_name'])
                        {
                            $medication_active[$key] = array(
                                "medication" => $_b['medication_name'],
                                "startdate" => $val['startdate'],
                                "stopdate" => $_b['date'],
                                "status" => 'inactive',
                                "dosage" => $_b['dosage'],
                                "providerId" => $_b['providerId'],
                                );

                        }
                    }
                }
            }


        }


        $collection_patient = $db->selectCollection($choose_collection_patient);
        $condition_patient = array("patient_random" => $patient_id, );
        $patient_name = $collection_patient->find($condition_patient);
        $patient_info = iterator_to_array($patient_name);
        
        $medname = $this->input->post('medname');
        $medname_option = $this->input->post('array-option');
        
        $medname_array = explode(',',$medname);
        $medname_option_array = explode(',',$medname_option);
        $data_med = array();
        foreach($medication_active as $key => $val){
            foreach($medname_array as $value){
                 if($val['medication'] == $value){
                    $data_med[] = $medication_active[$key];
                 }
            }
           
        }
        if($this->input->post('medrec-again')){
            
            $data_med = $this->input->post('medrec-again');
            $data_med = json_decode($data_med);
            if(count($data_med) > 0){
                
            foreach($data_med as $k => $val){
                $val = (array)$val;
                $med_name = $val['medication'];
                $med_who = $val['providerId'];
                $med_dosage = $val['dosage'];
                $value = $val['type2']; ;
                $who = '';
                $user_login = $this->session->userdata("user_id");
                if($user_login != ''){
                    $collection_user = $db->selectCollection('users');
                    $condition_user = array('user_id' => $user_login );
                    $data_user = $collection_user->find($condition_user);
                    $data_user = iterator_to_array($data_user);
                    foreach($data_user as $val_user){
                        $who = $val_user['UID'];
                    }
                }
                
                $document_medrec = array();
                $document_medrec['patient'] = $patient_id;
                $document_medrec['type1'] = 'MedRec';
                $document_medrec['type2'] = $value;
                $document_medrec['medication_name'] = $med_name;
                $document_medrec['dosage'] = $med_dosage;
                $document_medrec['providerId'] = $med_who;
                $document_medrec['who'] = $who;
                $datetime = new DateTime();
                $document_medrec['date'] = new MongoDate($datetime->getTimestamp());
                
                $collection->insert($document_medrec);
               
            }
            }
            $this->session->set_flashdata('success_message', 'Submit successfully!');
             redirect(base_url().'doctor/medications?id='.$patient_id.'&medication=active');
            
        }
        
        $template['patient_info'] = $patient_info;
        $template['data'] = $data_med;
        $template['data_1'] = $medname_option_array;
        $template['patient_id'] = $patient_id;
        
        $template['subview'] = 'doctor/confirm';
        $this->load->view('layouts/main', $template);
     

    }
}