<?php 

class Doctor extends MY_Controller
{
   
    protected $m;
   
    public function __construct()
    {
        parent::__construct();
        $this->load->model('doctor_model');
    }

    public function index()
    {
       $user_login = $this->session->userdata("user_id");
        
            $choose_collection_patient = 'patient_mapping';
            
            if($this->input->post('choose-patient-value')){
                $choose_patient = $this->input->post('choose-patient-value');
               $this->session->set_userdata('choose_patient', $choose_patient);
               $choose_patient = $this->session->userdata("choose_patient");
            }else{
                
                $choose_patient = $this->session->userdata("choose_patient");
               
            }
            
           	if($choose_patient){
           	    $choose_collection_patient = $choose_patient;
           	}else{
               $choose_collection_patient = 'patient_mapping';
            }
                
                $date = $this->input->post('date');
                $today = date("Y/m/d");
                $dates = new DateTime($today);
                
                $recent = modify_date($date, $dates);
                $config = array();
                
                if($date){
                    $config['base_url'] = base_url() . 'doctor/index?date='.$date;
                }else{
                    $date = $this->input->get('date');
                    if($date != ''){
                        $config['base_url'] = base_url() . 'doctor/index?date='.$date;
                    }else{
                        $config['base_url'] = base_url() . 'doctor/index';
                    }
                }
                
                 //get user requester
                $record_token = $this->doctor_model->get_all_user_requester($user_login);
                
                $array_patient_id = array();
               $list_id_by_user_share = array();
                if(count($record_token) > 0){
                    foreach($record_token as $val){
                        if(isset($val['owner'])){
                            $array_patient_id[] = $val['owner'];
                        }
                        
                         
                    }
                    
                    //get share patient
                    $list_id_by_user_share = $this->doctor_model->get_all_user_id_in_user($array_patient_id);
                    
                    $list_id_by_user_share = array_unique($list_id_by_user_share);
                    sort($list_id_by_user_share);
                    
                    //end get share patient
                    
                }
       
                $patient_id = '';
                if(!$date){
                    if($this->input->post('search-id')){
                        $patient_id = $this->input->post('search-id');
                       $config['base_url'] = base_url() . 'doctor/index?search='.$patient_id;
                    }else{
                        $patient_id = $this->input->get('search');
                        if($patient_id != ''){
                            $config['base_url'] = base_url() . 'doctor/index?search='.$patient_id;
                        }else{
                            $config['base_url'] = base_url() . 'doctor/index';
                        }
                    }
                }
               
                if($patient_id != ''){
                     
                    $data_real_id = $this->doctor_model->search_patient($choose_collection_patient, $patient_id);
                    
                    $a_r = array();
                    foreach($data_real_id as $v){
                        $a_r[] = $v['patient_random'];
                    }
                }
                 
                
                $template['patient_id_search'] = $patient_id;
                $nums_total = $this->doctor_model->count_all($recent, $list_id_by_user_share);
               
                $config['total_rows'] = $patient_id != '' ? count($a_r) : $nums_total['result'][0]['count'] ;
                $config['per_page'] = 20;
                $config['page_query_string'] = true;
                $config['query_string_segment'] = 'offset';
                $this->load->library('pagination', $config);
                $this->pagination->initialize($config);
                $start = 0;
                if($this->input->get('offset')){
                    $start = $this->input->get('offset');
                }
                $sort = -1;
                if($this->input->post('up') == 'up'){
                    $sort = 1;
                }
                //get all events and get all events by date
               
                $data = $this->doctor_model->find_all_events($recent, $patient_id, $a_r, $choose_collection_patient, $start, $config['per_page'], $list_id_by_user_share);
                
                //get all events by typ1 1 and by date
                $data_1 = $this->doctor_model->find_all_events_by_type1($recent, $patient_id,  $a_r, $sort, $user_login);
            //$count_documents = iterator_to_array($collection->find());

            //$template['count_documents'] = $count_documents;
            $template['sort'] = $sort;
            $template['data_1'] = $data_1;
            $template['val'] = $date;
            $template['data'] = $data;
            $template['subview'] = 'doctor/index';
            $this->load->view('layouts/main', $template);
        
       
    }
    public function providers(){
        $this->my_providers(); 
    }
    public function medications(){
        $this->my_medications();
    }
    public function encounters(){
        $this->my_encounters();
    }
    public function listEvents(){
        $this->my_listEvents();  
    }
    public function type2(){
        $this->my_type2();
    }
    public function eventDetail(){
        $this->my_eventDetail();
    }
     public function medrec(){
        $this->my_medrec();
    }
    public function confirm(){
        $this->my_confirm();
    }
}
?>