<?php 

class Patient extends MY_Controller
{
   
    protected $m;
    public function __construct()
    {
        parent::__construct();
        $this->load->model('patient_mapping_model');
    }

    public function index()
    {
        
                $user_login = $this->session->userdata("user_id");
                $choose_collection_patient = 'patient_mapping';
                $m = $this->m;
                $db = $m->selectDB("mydb");
                $collection = $db->selectCollection("events");
                
                $patient_id = $user_login;
                //add transfer
                
                $submit_transfer = $this->input->post('submit_transfer');
                if(isset($submit_transfer)){
                    $doctor_transfer = $this->input->post('doctor_transfer');
                    $transfer_patient_id = $this->input->post('transfer_patient_id');
                    
                    $collection_user = $db->selectCollection('patient_auth');
                    $collection_user->update(
                        array(
                            "user_id" => $user_login,
                            "doctor_transfer" => $doctor_transfer,
                            "transfer_patient_id" => $transfer_patient_id,
                            "status" => "0"
                        ),
                        array('$set' =>array(
                            'status' => "1"
                        ))
                    );
                    $this->session->unset_userdata("notication");
                    $template['success'] = 'You are accept transfer successfully!';
                }
                
                //end add transfer
                //cancel transfer
                $cancel = $this->input->post('cancel');
                if(isset($cancel)){
                    $doctor_transfer = $this->input->post('doctor_transfer');
                    $transfer_patient_id = $this->input->post('transfer_patient_id');
                    $collection_user = $db->selectCollection('patient_auth');
                    $collection_user->remove(
                        array(
                            'user_id' => $user_login,
                            "doctor_transfer" => $doctor_transfer,
                            "transfer_patient_id" => $transfer_patient_id,
                            "status" => "0"
                        ),
                        array("justOne" => true) 
                    );
                    $this->session->unset_userdata("notication");
                     $template['success'] = 'You are refuse transfer.';
                }
                
                
                //end cancel transfer

                
                 //Get list patient
                $collection_token = $db->selectCollection("patient_auth");
                $condition_token = array(
                    'requester' => $user_login,
                    'status' => "1"
                    
                );
                $record_token = $collection_token->find($condition_token);
                $record_token = iterator_to_array($record_token);
                
                $array_patient_id = array();
                $array_patient_id_real = array();
                if(count($record_token) > 0){
                    foreach($record_token as $val){
                        $array_patient_id[] = $val['owner'];
                    }
                                        
                                                     
                    $collection_id_real = $db->selectCollection("patient_mapping");
                    
                    $patient_id_real =$collection_id_real->aggregate(array(  
                            '$match' => array(
                                'patient' => array('$in' => $array_patient_id),
                            ),)                            
                    );
                    foreach($patient_id_real['result'] as $val){
                        $array_patient_id_real[] = $val['patient_random'];
                    }
                    
                }
                //get id in transfer
                $list_id_patient_in_patient_auth = $this->patient_mapping_model->get_id_patient_in_patient_auth($user_login);
                //end get id in transfer
                foreach($list_id_patient_in_patient_auth as $val){
                    array_push($array_patient_id_real, $val);
                }
                $datas=$collection->aggregate(array(  
                            
                            array(
                            '$match' => array(
                                'patient' => array('$in' => $array_patient_id_real),
                            ),),
                            
                            array(
                             '$group'=> 
                                array(
                                '_id'=>array('patient' => '$patient'),
                                'date'=>array('$max'=>'$date'),  
                                'books'=>array('$push' => '$$ROOT'),            
                                     )
                                 ), 
                            
                             array('$lookup' => array(
                                    'from' => $choose_collection_patient,
                                    'localField' => '_id.patient',
                                    'foreignField' => 'patient_random',
                                    'as' => 'name'
                            
                            )) ,
                        
                            )                            
                    );
                $data = $datas['result'];
              
                $datas_1=$collection->aggregate(array(  
                            
                            array(
                            '$match' => array('$or' => array(
                                array(
                                "type1" => "Hospital Dr Encounter",
                                'patient' => $patient_id,
                            ),
                            array(
                                "type1" => "Visit",
                                'patient' => $patient_id,
                            ),
                            array(
                                "type1" => "ER Dr. encounter",
                                'patient' => $patient_id,
                            ),
                            ), 
                            ),),
                            
                            array(
                             '$group'=> 
                                array(
                                '_id'=>array('patient' => '$patient'),
                                'date'=>array('$max'=>'$date'),  
                                       
                                     )
                                 ), 
                             
                            
                            )                            
                    );
            
            $data_1 = $datas_1['result'];
            
            $template['sort'] = $sort;
            $template['data_1'] = $data_1;
            $template['data'] = $data;
            
            //get  transfer notication
            $collection_user = $db->selectCollection('patient_auth');
            $condition_user = array(
                "user_id" => $user_login,
                "status" => "0",
            ); 
            $data_user = $collection_user->find($condition_user, array('transfer_patient_id','status'));
            $data_user = iterator_to_array($data_user);
            
            if(count($data_user) > 0){
                $this->session->set_userdata('notication', count($data_user));
            }
            
            //end get transfer
            $template['subview'] = 'patient/index';
            $this->load->view('layouts/main', $template);
  
    }
    public function providers(){
        $this->my_providers(); 
    }
    public function encounters(){
        $this->my_encounters();
    }
    public function medications(){
        $this->my_medications();
    }
     public function listEvents(){
        $this->my_listEvents();  
    }

    public function type2(){
        $this->my_type2();
    }
    public function eventDetail(){
        $this->my_eventDetail();
    }
    
   
}
?>