<?php 

class Token extends CI_Controller
{
   
    protected $m;
   
    public function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->helper('form');
        $this->load->library('session');
        $this->m = new MongoClient('mongodb://quang:quang@cluster0-shard-00-00-lra5a.mongodb.net:27017,cluster0-shard-00-01-lra5a.mongodb.net:27017,cluster0-shard-00-02-lra5a.mongodb.net:27017/admin?ssl=true&replicaSet=Cluster0-shard-0');
        
        $this->load->model('muser');
        $this->load->model('counter_model');
        $this->load->model('token_model');
        $user_login = $this->session->userdata("user_id");
        if($user_login == '') {
            redirect(base_url().'user/login');
        }
    }
    
    
  public function users(){
        
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("users");
                
        $type = $this->session->userdata("type");
        if($type == 'patient'):
            $template['next'] = 'no';
            $user_login = $this->session->userdata("user_id");
            $generate_token = $this->input->post('generate_token');
            
            /* Generate token*/
            if(isset($generate_token)){
                $template['token'] = $this->token_model->generate_token_user($user_login);  
            }
             /* End generate token*/
             
              /* Save patient - patient in patient auth*/
            $submit_token = $this->input->post('acces_token');
            if(isset($submit_token)){
                
                $acces_token = $this->input->post('acces_token');
                $record = $this->token_model->check_token($acces_token);
                
                if(count($record) > 0){ // if patient token is true

                    foreach($record as $val){
                        $patient_id = $val['user_id'];
                    }
                    // update status = 1
                    $save_status = $this->token_model->save_status($patient_id, $user_login);
                    if($save_status > 0){
                        $template['success'] = "Patient token is added successfully!!";
                    }else{
                        $template['success'] = "Patient has remove token";
                    }                   
                    
                }else{
                    $template['error'] = "Token is incorrect";
                    $template['next'] = 'no';
                } 
        }
        
            /* End Save doctor - patient in patient auth*/
            /* Get list patient in patient manager*/
            $collection_token = $db->selectCollection("patient_auth");
                $condition_token = array(
                    'requester' => $user_login,
                    'status' => "1"
                    
                );
                $record_token = $collection_token->find($condition_token);
                $record_token = iterator_to_array($record_token);
                
                $array_patient_id = array();
                $array_patient_id_real = array();
                if(count($record_token) > 0){
                    foreach($record_token as $val){
                        $array_patient_id[] = $val['owner'];
                    }
                    $collection_id_real = $db->selectCollection("users");
                    
                    $patient_id_real =$collection_id_real->aggregate(array(  
                            '$match' => array(
                                'user_id' => array('$in' => $array_patient_id),
                            ),)                            
                    );
                    
                    $list_patient = $patient_id_real['result'];
                    $template['list_patient'] = $list_patient;
                }
                
            $next = $this->input->post('next');
            if(isset($next)){
                $template['next'] = 'yes';
            }
            /* End Get list patient in doctor manager*/
            $template['subview'] = 'token/users';
            $this->load->view('layouts/main', $template);
        
        else:
            redirect(base_url().'error');
        endif;
    }
    public function doctor(){
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("users");
                
        $type = $this->session->userdata("type");
        if($type == 'doctor'):
            $template['next'] = 'no';
            $user_login = $this->session->userdata("user_id");
            $generate_token = $this->input->post('generate_token');
            
            /* Generate token*/
            if(isset($generate_token)){      
                $template['token'] = $this->token_model->generate_token_doctor($user_login);
            }
             /* End generate token*/
             
              /* Save doctor - patient in patient auth*/
            $submit_token = $this->input->post('acces_token');
            if(isset($submit_token)){
                $acces_token = $this->input->post('acces_token');
                
                $record = $this->token_model->check_token($acces_token);
                if(count($record) > 0){ // if patient token is true
                   
                    foreach($record as $val){
                        $patient_id = $val['user_id'];
                    }
                    // update status = 1
                    $save_status = $this->token_model->save_status($patient_id, $user_login);
                    if($save_status > 0){
                        $template['success'] = "Patient token is added successfully!!";
                    }else{
                        $template['success'] = "Patient has remove token";
                    }
                        
                }else{
                    $template['error'] = "Token is incorrect";
                    $template['next'] = 'yes';
                } 
            }
        
            /* End Save doctor - patient in patient auth*/
            
            /* Get list patient in doctor manager*/
            $collection_token = $db->selectCollection("patient_auth");
                $condition_token = array(
                    'requester' => $user_login,
                    'status' => "1"
                    
                );
                $record_token = $collection_token->find($condition_token);
                $record_token = iterator_to_array($record_token);
                
                $array_patient_id = array();
                $array_patient_id_real = array();
                if(count($record_token) > 0){
                    foreach($record_token as $val){
                        $array_patient_id[] = $val['owner'];
                    }
                    $collection_id_real = $db->selectCollection("users");
                    
                    $patient_id_real =$collection_id_real->aggregate(array(  
                            '$match' => array(
                                'user_id' => array('$in' => $array_patient_id),
                            ),)                            
                    );
                    
                    $list_patient = $patient_id_real['result'];
                    $template['list_patient'] = $list_patient;
                }
            /* End Get list patient in doctor manager*/
            
            $next = $this->input->post('next');
            if(isset($next)){
                $template['next'] = 'yes';
            }
            $template['subview'] = 'token/doctor';
            $this->load->view('layouts/main', $template);
        
        else:
            redirect(base_url().'error');
        endif;
    }
    public function remove(){
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("patient_auth");
                
        $patient_id = $this->input->post('id');
        $doctor_id = $this->input->post('doctor_id');
        $collection->remove(
            
            array(
                "owner" => $patient_id,
                "requester" => $doctor_id,
            
            ),
            array("justOne" => true)
        );
        return 0;
        
    }
    public function remove_doctor(){
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("patient_auth");
                
        $doctor_id = $this->input->post('id');
        $patient_id = $this->input->post('patient_id');
        $collection->remove(
            
            array(
                "owner" => $patient_id,
                "requester" => $doctor_id,
            ),
            array("justOne" => true)
        );
        
    }
    public function patient(){
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $collection = $db->selectCollection("users");
        $collection_patient = $db->selectCollection("patient_auth");
        $type = $this->session->userdata("type");
        if($type == 'patient'):
            $user_login = $this->session->userdata("user_id");
            
            $submit_token = $this->input->post('submit_token');
            
            /*Generate patient token*/
            if(isset($submit_token)){
                
                //check token doctor
                $acces_token = $this->input->post('acces_token');
                $record = $this->token_model->check_token($acces_token);
                
                if(count($record) > 0){ // If doctor token is true
                    foreach($record as $val){
                        $doctor_id = $val['user_id'];
                    }
                   
                        $template['token'] = $this->token_model->generate_token_user($user_login);
                        //save status = 0
                        $this->token_model->save_status_request($user_login, $doctor_id);                        
                        //end save status = 0
                            
                }else{
                    $template['error'] = "Token is incorrect";
                }   
                //end check token doctor
                
            }
             /*End Generate patient token*/
             //Get list doctor and patient
            $collection_token = $db->selectCollection("patient_auth");
                $condition_token = array(
                    'owner' => $user_login,
                    'status' => "1"
                    
                );
                $record_token = $collection_token->find($condition_token);
                $record_token = iterator_to_array($record_token);
                
                $array_patient_id = array();
                $array_patient_id_real = array();
                if(count($record_token) > 0){
                    foreach($record_token as $val){
                        $array_patient_id[] = $val['requester'];
                    }
                    $collection_id_real = $db->selectCollection("users");
                    
                    $patient_id_real =$collection_id_real->aggregate(array(  
                            '$match' => array(
                                'user_id' => array('$in' => $array_patient_id),
                            ),)                            
                    );
                    
                    $list_patient = $patient_id_real['result'];
                    $template['list_doctor'] = $list_patient;
                }
            
            $template['subview'] = 'token/patient';
            $this->load->view('layouts/main', $template);
        
        else:
            redirect(base_url().'error');
        endif;
    }
    
    
    
}