<?php 

class Transfer extends CI_Controller
{
   
    protected $m;
    public function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->helper('form');
        $this->load->library('session');
        $this->load->model('token_model');
        
        $this->m = new MongoClient('mongodb://quang:quang@cluster0-shard-00-00-lra5a.mongodb.net:27017,cluster0-shard-00-01-lra5a.mongodb.net:27017,cluster0-shard-00-02-lra5a.mongodb.net:27017/admin?ssl=true&replicaSet=Cluster0-shard-0');
        
        $user_login = $this->session->userdata("user_id");
        if($user_login == '') {
            redirect(base_url().'user/login');
        }
    }
    public function user(){
        $type = $this->session->userdata("type");
        if($type == 'patient'):
            $user_login = $this->session->userdata("user_id");
            /*Generate patient token*/
            $submit_token = $this->input->post('submit_token');
            if(isset($submit_token)){
                $acces_token = $this->input->post('acces_token');
                $record = $this->token_model->check_token($acces_token);
                if(count($record) > 0){ // If doctor token is true
                    foreach($record as $val){
                        $doctor_id = $val['user_id'];
                    }
                        $template['token'] = $this->token_model->generate_token_user($user_login);
                                 
                }else{
                    $template['error'] = "Token is incorrect";
                }   
            }
             /*End Generate patient token*/
            
            $template['subview'] = 'transfer/user';
            $this->load->view('layouts/main', $template);
        
        else:
            redirect(base_url().'error');
        endif;
    
    }
 
    public function Index(){
        $type = $this->session->userdata("type");
        if($type == 'admin'):
        $m = $this->m;
        $db = $m->selectDB("mydb");
        $patient_id = $this->input->get('id');
        $user_login = $this->session->userdata("user_id");
        
        //generate token
        $template['token'] = $this->token_model->generate_token_doctor($user_login);
        // end generate token
        //get patient info
        $collection_patient = $db->selectCollection('patient_mapping');
        $condition_patient = array("patient_random" => $patient_id, );
        $patient_name = $collection_patient->find($condition_patient);
        $patient_info = iterator_to_array($patient_name);
        $template['patient_info'] = $patient_info;
        //end get patient info
        

        //submit
            $transfer = $this->input->post('transfer');
            if(isset($transfer)){
                $user_token = $this->input->post('user_token');
                $user_id = $this->token_model->get_user_by_token($user_token);
                
                $data_insert = array(
                    "user_id" => $user_id,
                    "transfer_patient_id" => $patient_id,
                    "doctor_transfer" => $user_login,
                );
                //check has been data
                $check_data_insert = $this->token_model->check_data_insert($data_insert);
                // end check has been data
                if(count($check_data_insert) == 0){
                    $data_insert = array(
                        "user_id" => $user_id,
                        "transfer_patient_id" => $patient_id,
                        "doctor_transfer" => $user_login,
                        'status' => "0"
                    );
                    $this->token_model->insert_transfer($data_insert);
                }
                
                $template['success'] = 'Successfully!';
                
            }
            //end submit
        $template['subview'] = 'transfer';
        $this->load->view('layouts/main', $template);
        else:
            redirect(base_url().'error');
        endif;
    }
    public function confirm(){
        $type = $this->session->userdata("type");
        if($type == 'patient'):
            $user_login = $this->session->userdata("user_id");
            
            //get  patient name and doctor name
            $data_name = $this->token_model->get_patient_doctor($user_login);
            $template['data_name'] = $data_name;
        
               
            $template['subview'] = 'patient/transfer';
            $this->load->view('layouts/main', $template);
            
        else:
            redirect(base_url().'error');
        endif;
    }
}
?>