<h3 style="border-bottom: 1px solid gray; padding: 0 0 20px 0;">Create user</h3>
<div class="col-sm-6">
<?php 
$message = $this->session->flashdata('success_message');
$message_error = $this->session->flashdata('error_message');
if ($message):
?>
<p class="alert-success">
<?php echo $message; ?>
</p>
<?php endif; ?>
<?php if ($message_error): ?>
<p class="alert-success">
<?php echo $message_error; ?>
</p>
<?php endif; ?>
<p>If you have been account, please <a href="<?php echo base_url()?>user/login">login</a>.</p>
<?php echo validation_errors();?>
<form method="post"action="<?php echo base_url()?>user/create">
<div class="row">
<div class="col-md-6">
  <div class="form-group">
    <label for="user_id">User ID</label>
    <input type="text" name="user_id"class="form-control" required id="user_id">
  </div>
  <div class="form-group">
    <label for="first_name">First name</label>
    <input name="first_name" type="text" class="form-control" required id="first_name">
  </div>
  <div class="form-group">
    <label for="last_name">Last name</label>
    <input name="last_name" type="text" class="form-control" required id="last_name">
  </div>
  <div class="form-group">
    <label for="type">Role</label>
	<br>
    <select id="type" name="type">
		<option value="doctor" >Doctor</option>
		<option value="patient"selected="true" >Patient</option>
	</select>
  </div>
  <button type="submit" class="btn btn-success">Submit</button>
  </div>
  <div class="col-md-6" id="doctor_info" style="display: none;">
    <div class="form-group required ">
        <label for="doctor_name">Name of Doctor</label>
        <input type="text" name="doctor_name"class="form-control"  id="doctor_name">
    </div>
     <div class="form-group required">
        <label for="doctor_address">Address</label>
        <input type="text" name="doctor_address"class="form-control"  id="doctor_address">
    </div>
     <div class="form-group required">
        <label for="phone_number">Phone:</label>
        <input type="text" name="phone_number"class="form-control"  id="phone_number">
    </div>
     <div class="form-group required">
        <label for="doctor_name">Dr. License ID</label>
        <input type="text" name="license_id"class="form-control"  id="license_id">
    </div>
    <div class="form-group">
        <label for="password">Password</label>
        <p>This value can empty.</p>
        <input type="text" name="password"class="form-control" id="password">
    </div>
  </div>
  </div>
</form>
</div>
<script>
    $(document).ready(function(){   
        $('#type').change(function(){
            var val = $(this).val();
            if(val == 'doctor'){
                $('#doctor_info').fadeIn();
                $('#doctor_info .required input').attr('required','');
            }
            if(val == 'patient'){
                $('#doctor_info').fadeOut();
                $('#doctor_info .required input').attr('required',false);
            }
        });
    });
</script>
